import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class DCT_IDCT extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public DCT_IDCT()
   {  setSize(800,400);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double[] DCT(double []X, int Num)  // DCT(UIRTCϊ)
   { double [] Y = new double[Num+1];
     double PI = 6.28318530717959 / 2;
     double C0= 1 / Math.sqrt(Num); double Cn0 = Math.sqrt(2.0) * C0;
     for(int k = 0; k < Num; k++)
     { Y[k] = 0;
       for(int j = 0; j < Num; j++)
          Y[k] += X[j] * Math.cos(((double)(2 * j + 1)) * k * PI / (2 * Num));
       if(k==0)   Y[k] *= C0;  else Y[k] *= Cn0;
      }
      Y[Num] = 0;
      return Y;
   }
   private double[] IDCT(double []Y, int Num)  // IDT(UIRTCtϊ)
   { double [] Z = new double[Num+1];
     double PI = 6.28318530717959 / 2;
     double C0= 1.0 / Math.sqrt(2.0); double C = Math.sqrt(2.0 / ((double)Num));
     for(int j = 0; j < Num; j++)
     {  Z[j] = C0 * Y[0];
        for(int k = 1; k < Num; k++)
           Z[j] += Y[k] * Math.cos(((double)(2 * j + 1)) * k * PI / (2 * Num));
        Z[j] *= C;
     }
     Z[Num] = Z[0];
     return Z;
  }
  private double[] Pulse(int Num)
  { double []X = new double[Num+1];
    int N1= 3 * Num / 10; int N2 = 8 * Num / 10;
    for(int k = 0; k < Num; k++)
    { X[k]=-1; if(k >= N1 && k < N2) X[k] = 1;
    }
    X[Num] = X[0];
    return X;
  }

   public int Xpos(double X)
   {  return (int)(X*50)+100;}
   public int Ypos(double Y)
   {  return 200- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { 
     int Max = 100;int i,k; boolean Flag = false;
     double [] X  = Pulse(Max);
     double [] Y1 = DCT (X, Max);
     double [] Y2 = IDCT(Y1, Max);

     setTitle("DCT, IDCT");
     g.drawString("pXDCTIDCT",100,100);
     g.drawString("DCT",210,200);
     g.drawString("IDCT",210,300);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, X[k]/2, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02+3.5, Y1[k]/5, Flag);
     
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, Y2[k]/2-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new DCT_IDCT();
      w.setVisible(true);
   }
}
